/* AppleSingle/Double t@C̓ǉ */
/*   Copyright(c)2000,2003 by T.Toda */
#include <stdio.h>

#ifdef	MSDOS
#define	OPENMODE	"rb"
#else
#define	OPENMODE	"r"
#endif

static	char	*idtext[]
	= {"Unknown", "Data Fork", "Resource Fork", "Real Name", 
	   "Comment", "BW Icon", "Color Icon", "File Info", 
	   "File Dates", "Finder Info", "Mac File Info", "ProDos File Info", 
	   "MSDOS File Info", "Short Name", "AFP File Info", "Directory ID"};

static	void	puthex(unsigned long, int);
static	unsigned long	makelong(unsigned char *);
static	unsigned short	makeshort(unsigned char *);

int	main(int argc, char **argv, char **envp)
{
	FILE	*fp;
	struct{
		unsigned char	magic[4];
		unsigned char	version[4];
		char	filler[16];
		unsigned char	entries[2];
	}	header;
	struct{
		unsigned char	id[4];
		unsigned char	offset[4];
		unsigned char	length[4];
	}	entry;
	unsigned char	buffer[64];
	unsigned long	i_id, i_offset, i_length;
	unsigned short	i_entries;
	unsigned short	i;
	unsigned long	filename = 0, filedate = 0, finderinfo = 0;
	unsigned long	filenamelen;

	if( argc > 2 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [infile]]\n", stderr);
		return	4;
	}
	if( argc < 2 ){
		fp = stdin;
	}
	else if(( fp = fopen(argv[1],OPENMODE)) == NULL ){
		fputs("Can't Open '", stderr);
		fputs(argv[1], stderr);
		fputs("'.\n", stderr);
		return	8;
	}
	fread(&header, sizeof(header), 1, fp);
	fputs("Magic: ", stdout);	puthex(makelong(header.magic), 8);
	fputs("  Version: ", stdout);	puthex(makelong(header.version), 8);
	i_entries = makeshort(header.entries);
	fputs("\nNumber of Entries: ", stdout); puthex(i_entries, 4);
	fputs("\nFillers:", stdout);
	for( i = 0 ; i < 16 ; i++ ){
		putchar(' ');
		puthex(header.filler[i], 2);
	}
	putchar('\n');
	for( i = 0 ; i < i_entries ; i++ ){
		fread(&entry, sizeof(entry), 1, fp);
		i_offset = makelong(entry.offset);
		i_length = makelong(entry.length);
		puthex(i_offset, 8);	putchar('-');
		puthex(i_offset + i_length, 8);	putchar('(');
		puthex(i_length, 8);
		i_id = makelong(entry.id);
		fputs(") ID=", stdout);	puthex(i_id, 4);
		putchar(' ');
		fputs(idtext[ i_id < 16 ? i_id : 0 ], stdout);
		putchar('\n');
		switch( i_id ){
		case 3:
			filename = i_offset;
			filenamelen = i_length;
			break;
		case 8:
			filedate = i_offset;
			break;
		case 9:
			finderinfo = i_offset;
			break;
		}
	}
	if( filename ){
		if( filenamelen > 63 )filenamelen = 63;
		fseek(fp, (signed long)filename, 0);
		fread(buffer, (unsigned short)filenamelen, 1, fp);
		fputs("RealName: '", stdout);
		for( i = 0 ; i < (unsigned short)filenamelen ; i++ ){
			putchar(buffer[i]);
		}
		fputs("'\n", stdout);
	}
	if( finderinfo ){
		fseek(fp, (signed long)finderinfo, 0);
		fread(buffer, 16, 1, fp);
		fputs("FileType: '", stdout);
		for( i = 0 ; i < 4 ; i++ ){
			putchar(buffer[i]);
		}
		fputs("'  Creator: '", stdout);
		for( i = 4 ; i < 8 ; i++ ){
			putchar(buffer[i]);
		}
		fputs("'\nPosition: (", stdout);
		puthex(makeshort(buffer + 12), 4);
		fputs("H,", stdout);
		puthex(makeshort(buffer + 10), 4);
		fputs("H)    Finder Flag: ", stdout);
		puthex(buffer[8], 2);
		puthex(buffer[9], 2);
		fputs("H    Folder ID: ", stdout);
		puthex(makeshort(buffer + 14), 4);
		fputs("H\n", stdout);
	}
	if( filedate ){
		fseek(fp, (signed long)filedate, 0);
		fread(buffer, 16, 1, fp);
		fputs("Created Date Data: ", stdout);
		puthex(makelong(buffer), 8);
		fputs("H    Modified Date Data: ", stdout);
		puthex(makelong(buffer + 4), 8);
		fputs("H\nBackup Date Data:  ", stdout);
		puthex(makelong(buffer + 8), 8);
		fputs("H    Access Date Data:   ", stdout);
		puthex(makelong(buffer + 12), 8);
		fputs("H\n", stdout);
	}
	return	0;
}

static void	puthex(unsigned long c, int l)
{
	static	char	const	hexnum[] = "0123456789ABCDEF";
	char	result[9];

	if(l > 8)l = 8;
	if(l < 1)l = 1;
	result[l] = 0;
	result[--l] = hexnum[c % 0x10];
	while( l-- )
		result[l] = hexnum[(c >>= 4) % 0x10];
	fputs(result, stdout);
}

static	unsigned long	makelong(unsigned char *buffer)
{
	return	( ((long)buffer[0] << 24 ) | 
	      	  ((long)buffer[1] << 16 ) | 
	      	  ((long)buffer[2] <<  8 ) | 
	      	  ((long)buffer[3] ) );
}

static	unsigned short	makeshort(unsigned char *buffer)
{
	return	( ((long)buffer[0] <<  8 ) | 
	      	  ((long)buffer[1] ) );
}
