/* BinHex(HQX)̃wb_𓾂 */
/*    Copyright(c)2003 by T.Toda */
#include <stdio.h>

static	void	fputhex(unsigned long, int, FILE *);
static	unsigned long	makelong(unsigned char *);
static	unsigned short	makeshort(unsigned char *);
static	int	get6bit(void), get8bit(void), runlength(void);
static	FILE	*fpin;

int	main(int argc, char **argv, char **envp)
{
	int	c, i = 0;
	unsigned long	rf_len, df_len;
	char	linebuf[80];
	unsigned char	numbuf[4];

	if( argc > 2 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [infile]\n", stderr);
		return	4;
	}
	if( argc < 2 ){
		fpin = stdin;
	}
	else if(( fpin = fopen(argv[1],"r")) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[1],stderr);
		fputs("'.\n",stderr);
		return	8;
	}

	for(;;){
		if( fgets(linebuf, 80, fpin) == NULL ){
			return	4;
		}
		if( strcmp("(This file must be converted with BinHex 4.0)\n", linebuf) == 0 ){
			break;
		}
	}

	while( (c = getc(fpin)) != ':' ){
		if( c == EOF ){
			return	4;
		}
	}

	fputs("File Name: ", stdout);
	i = runlength();
	while( i-- ){
		 putchar(runlength());
	}
	putchar('\n');
	if( c = runlength() ){
		fputs("Invalid Terminator: ", stdout);
		fputhex(c, 2, stdout);
		putchar('\n');
	}
	fputs("Type: ", stdout);
	for( i = 0 ; i < 4 ; i++ ){
		putchar(runlength());
	}
	fputs("    Creator: ", stdout);
	for( i = 0 ; i < 4 ; i++ ){
		putchar(runlength());
	}
	fputs("    Flags: ", stdout);
	for( i = 0 ; i < 2 ; i++ ){
		fputhex(runlength(), 2, stdout);
	}
	putchar('\n');
	fputs("Size of DF: ", stdout);
	for( i = 0 ; i < 4 ; i++ ){
		numbuf[i] = runlength();
	}
	df_len = makelong(numbuf);
	fputhex(df_len, 8, stdout);
	fputs("    Size of RF: ", stdout);
	for( i = 0 ; i < 4 ; i++ ){
		numbuf[i] = runlength();
	}
	rf_len = makelong(numbuf);
	fputhex(rf_len, 8, stdout);
	fputs("    CRC of Header: ", stdout);
	for( i = 0 ; i < 2 ; i++ ){
		numbuf[i] = runlength();
	}
	fputhex(makeshort(numbuf), 4, stdout);
	putchar('\n');

	return	0;
}

static	int	runlength()
{
	static	int	c0 = 0, wait = 0, cont = 0;
	int	c;

	for(;;){
		if( c0 == EOF ){
			return	EOF;
		}
		else if( wait ){
			wait--;
		}
		else if( (c = get8bit()) != 0x90 ){
			c0 = c;
			cont = 0;
		}
		/* kf[^̒0x90Ƃ̋͋Kił͞B     */
		/* kƂ͊Ř􂳂ɐf[^ƊŘ􂷂Ƃ߂ƁA     */
		/* sƓp^[ēxWJƂ߂\łA */
		/* ̔f͌҂̏ꍇ if( (c = get8bit()) != 0x90 )   */
		/* O҂̏ꍇ if( ((c = get8bit()) != 0x90) || cont )       */
		else{
			wait = get8bit();
			if( wait == EOF ){
				c0 = EOF;
			}
			else if( wait == 0 ){
				c0 = 0x90;
				cont = 0;
			}
			else{
				if( cont )wait++;
				cont = 1;
				if( wait == 1 ){
					wait = 0;
					continue;
				}
				else{
					wait -= 2;
				}
			}
		}
		return	c0;
	}
}

static	int	get8bit()
{
	static	int	i = 0;
	static	int	buffer[3];
	int	c;

	switch( i ){
	default:
		if( (c = get6bit()) == EOF ){
			buffer[0] = buffer[1] = buffer[2] = EOF;
		}
		else{
			buffer[0] = c << 2;
			if( (c = get6bit()) == EOF ){
				buffer[0] = buffer[1] = buffer[2] = EOF;
			}
			else{
				buffer[0] |= c >> 4;
				buffer[0] &= 0xff;
				buffer[1] = c << 4;
				if( (c = get6bit()) == EOF ){
					buffer[1] = buffer[2] = EOF;
				}
				else{
					buffer[1] |= c >> 2;
					buffer[1] &= 0xff;
					buffer[2] = c << 6;
					if( (c = get6bit()) == EOF ){
						buffer[2] = EOF;
					}
					else{
						buffer[2] |= c;
						buffer[2] &= 0xff;
					}
				}
			}
		}
		i = 1;
		return	buffer[0];
	case	1:
		if( buffer[1] != EOF )i = 2;
		return	buffer[1];
	case	2:
		if( buffer[2] != EOF )i = 0;
		return	buffer[2];
	}
}

static	int	get6bit()
{
	int	c;

	for(;;){
		c = getc(fpin);
		if( c >= '!' && c <= '-' ){
			return	c - '!';
		}
		else if( c >= '0' && c <= '6' ){
			return	c + 13 - '0';
		}
		else if( c >= '8' && c <= '9' ){
			return	c + 20 - '8';
		}
		else if( c >= '@' && c <= 'N' ){
			return	c + 22 - '@';
		}
		else if( c >= 'P' && c <= 'V' ){
			return	c + 37 - 'P';
		}
		else if( c >= 'X' && c <= '[' ){
			return	c + 44 - 'X';
		}
		else if( c >= '`' && c <= 'f' ){
			return	c + 48 - '`';
		}
		else if( c >= 'h' && c <= 'm' ){
			return	c + 55 - 'h';
		}
		else if( c >= 'p' && c <= 'r' ){
			return	c + 61 - 'p';
		}
		else if( c == ':' || c == EOF ){
			return	EOF;
		}
	}
}

static void	fputhex(unsigned long c, int l, FILE *fp)
{
	static	char	const	hexnum[] = "0123456789ABCDEF";
	char	result[9];

	if(l > 8)l = 8;
	if(l < 1)l = 1;
	result[l] = 0;
	result[--l] = hexnum[c % 0x10];
	while( l-- )
		result[l] = hexnum[(c >>= 4) % 0x10];
	fputs(result, fp);
}

static	unsigned long	makelong(unsigned char *buffer)
{
	return	( ((long)buffer[0] << 24 ) | 
	      	  ((long)buffer[1] << 16 ) | 
	      	  ((long)buffer[2] <<  8 ) | 
	      	  ((long)buffer[3] ) );
}

static	unsigned short	makeshort(unsigned char *buffer)
{
	return	( ((long)buffer[0] <<  8 ) | 
	      	  ((long)buffer[1] ) );
}
